using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.Events;
using UnityEditor;
using System.Collections;
using System.Collections.Generic;
using MacGruber;

//20240429@14mhz
//https://docs.unity3d.com/ScriptReference/GUI.html





public class View2Atom : MVRScript
{//  Init -> Start -> OnGUI <-> Update
    public View2Atom()
    {

    }
	
    private KeyCode          hotkey_V2A; //KeyCode.Alpha1;
    private KeyCode          hotkey_A2V; //KeyCode.Alpha2;
    private JSONStorableBool enableUpdatePlayerHeightAdjust;

    public static List<string> hotkeylist = Enum.GetNames(typeof(KeyCode)).ToList();
    
    public override void Init()
    {
        View2AtomUtil.HOME = View2AtomUtil.GetPluginPath(this);
       if (true) SuperController.LogMessage("[INF] plugin path : " + View2AtomUtil.HOME );
       
        /////////////////////////////// legacy mode

        Utils.OnInitUI(CreateUIElement);

        Utils.SetupInfoText(
            this,
            "<color=#000><size=35><b>View2Atom v0.2 @14mhz</b></size></color>\n"
                + "<color=#333>"
                + "View2Atom(easily making camride)\n"
                + "</color>",
            110.0f,
            false
        );

        Utils.SetupInfoText(
            this,
            "",
            110.0f,
            true
        );

        Utils.SetupInfoOneLine(this, "<size=30><b>v0.1 Legacy Functions</b></size>", false);
        Utils.SetupInfoOneLine(this, "<size=30><b>v0.1 description</b></size>", true);
        
        try
        {
             {
                var action = new JSONStorableAction("Fit View2Atom", FitView2Atom);
                RegisterAction(action);
                
                UIDynamicButton btn = CreateButton("Fit View2Atom");
                btn.button.onClick.AddListener(FitView2Atom);
                action.dynamicButton = btn;
                
                JSONStorableStringChooser chooser = new JSONStorableStringChooser("Shortcut Key", hotkeylist, hotkey_V2A.ToString(), "Shortcut Key");
                RegisterStringChooser(chooser);
                chooser.setCallbackFunction += OnHotkeyChangedView2Atom;
                CreateScrollablePopup(chooser);
            }
    
            CreateTextField(new JSONStorableString("text", "Press <b>Fit View2Atom</b> or the Shortcut key to align Player View to Atom (or Camera) .\n\nPress <b>Fit Atom2View</b> or the Shortcut key to align Atom (or Camera) to Player View."), true).height = 280;
    
            {
                var action = new JSONStorableAction("Fit Atom2View", FitAtom2View);
                RegisterAction(action);                
                
                UIDynamicButton btn = CreateButton("Fit Atom2View");
                btn.button.onClick.AddListener(FitAtom2View);
                action.dynamicButton = btn;                
                
                JSONStorableStringChooser chooser = new JSONStorableStringChooser("Shortcut Key", hotkeylist, hotkey_A2V.ToString(), "Shortcut Key");
                RegisterStringChooser(chooser);
                chooser.setCallbackFunction += OnHotkeyChangedAtom2View;
                CreateScrollablePopup(chooser);                
                
                enableUpdatePlayerHeightAdjust = new JSONStorableBool("Enable Update Player Height Adjust", true);
                RegisterBool(enableUpdatePlayerHeightAdjust);
                CreateToggle(enableUpdatePlayerHeightAdjust, true);
            }
        }
        catch (Exception e)
        {
            SuperController.LogError("Failed to init: " + e);
            DestroyImmediate(this);
        } 
        
        ///////////////////////////////
        
        Utils.SetupInfoOneLine(this, "<size=30><b>v0.2 New Functions</b></size>", false);
        Utils.SetupInfoOneLine(this, "<size=30><b>v0.2 description</b></size>", true);
        
        InitHUD();        
        
        hideHUD = new JSONStorableBool("hide HUD", false);
        CreateToggle(hideHUD, false);
        RegisterBool(hideHUD);
        hideHUD.storeType = JSONStorableParam.StoreType.Full;
        
        invertZ = new JSONStorableBool("Invert Z", false);
        CreateToggle(invertZ, false);
        RegisterBool(invertZ);
        invertZ.storeType = JSONStorableParam.StoreType.Full;
   
        WORLD_X = new JSONStorableFloat("world_x", 8f, (float v) => { int x = (int)((int)v)/2*2; if (x != world_w) { world_w = world_h = x; maps.revalidate(); }},2f, 32f);
        CreateSlider(WORLD_X, false);
        RegisterFloat(WORLD_X);
        WORLD_X.storeType = JSONStorableParam.StoreType.Full;
        
        CreateTextField(new JSONStorableString("text", "" +
        			"<b>hide HUD:</b> Open/Hide GUI Hud on VAM screen. GUI Hud can adjust new camera angle/position for tweaking. \n" +
        			"<b>Invert Z:</b> Invert between z-axsis within a hud map. \n" + 
        			"<b>world x:</b> Choose between available hud map rage within 2x2 ~ 32x32. \n"
        ), true).height = 252;
    
        
        ////
        
        maps.enable_Person  = new JSONStorableBool("Enable Person ", true); 
        maps.enable_Empty   = new JSONStorableBool("Enable Empty  ", false); 
        maps.enable_Light   = new JSONStorableBool("Enable Light  ", false); 
        maps.enable_Misc    = new JSONStorableBool("Enable Misc   ", false); 
        maps.enable_Asset   = new JSONStorableBool("Enable Asset  ", false); 
                                                                    
        maps.enable_Camera  = new JSONStorableBool("Enable Camera ", true); 
        maps.enable_Sound   = new JSONStorableBool("Enable Sound  ", false); 
        maps.enable_Trigger = new JSONStorableBool("Enable Trigger", false); 
        maps.enable_Shapes  = new JSONStorableBool("Enable Shapes ", false); 
        maps.enable_Another = new JSONStorableBool("Enable Another", false); 
        
        CreateToggle(maps.enable_Person , false);
        CreateToggle(maps.enable_Empty  , false);
        CreateToggle(maps.enable_Light  , false);
        CreateToggle(maps.enable_Misc   , false);
        CreateToggle(maps.enable_Asset  , false);
                                            
        CreateToggle(maps.enable_Camera , false);
        CreateToggle(maps.enable_Sound  , false);
        CreateToggle(maps.enable_Trigger, false);
        CreateToggle(maps.enable_Shapes , false);
        CreateToggle(maps.enable_Another, false);
        
        RegisterBool(maps.enable_Person ); 
        RegisterBool(maps.enable_Empty  ); 
        RegisterBool(maps.enable_Light  ); 
        RegisterBool(maps.enable_Misc   ); 
        RegisterBool(maps.enable_Asset  ); 
                                            
        RegisterBool(maps.enable_Camera ); 
        RegisterBool(maps.enable_Sound  ); 
        RegisterBool(maps.enable_Trigger); 
        RegisterBool(maps.enable_Shapes ); 
        RegisterBool(maps.enable_Another); 
        
        CreateTextField(new JSONStorableString("text",  "" +
        			"<b>Enable Person:</b> Selective Atom type <i>Person</i> \n" +
        			"<b>Enable Empty:</b> Selective Atom type <i>Empty</i> \n" +
        			"<b>Enable Light:</b> Selective Atom type <i>Light</i> \n" +
        			"<b>Enable Asset:</b> Selective Atom type <i>UnityAsset</i> \n" +
        			"<b>Enable Camera:</b> Selective Atom type <i>Camera</i> \n" +
        			"<b>Enable Sound:</b> Selective Atom type <i>Sound</i> \n" +
        			"<b>Enable Trigger:</b> Selective Atom type <i>Trigger</i> \n" +
        			"<b>Enable Shapes:</b> Selective Atom type <i>Shapes</i> \n" +
        			"<b>Enable Another:</b> Selective Atom type <i>Another else ...</i> \n"
        ), true).height = 635;
        
        ////
        
        Utils.SetupInfoOneLine(this, "<size=30><b>Button Action</b></size>", false);
        Utils.SetupInfoOneLine(this, "<size=30><b> </b></size>", true);
        
        CreateTextField(new JSONStorableString("text", "" +
        			"<b>Fit Cam2View<i>N</i>:</b> Press <b>Buttons</b> to align Camera to Player View. \n\n\n\n\n\n" +
        			"<color=#606060><size=40><b>Next Version v0.3</b></size>\n" + 
        			"- Smooth animated movement between camera buttons.\n" +
        			"- Support Shotcut Key with 10 more camera angle.\n" +
        			"- Advanced graphical user interface using Hud.\n" +
        			"</color>\n\n"

        ), true).height = 635;
        
        registerAction();
        registerTransform();
        
        StartCoroutine(InitDeferred());
    }

    /////////////////////////////////// legacy mode
    
    private void OnHotkeyChangedView2Atom(string key)
    {
        if (false) SuperController.LogMessage("[INF] View2Atom key changed : " + key);
        
        hotkey_V2A = (KeyCode)Enum.Parse(typeof(KeyCode), key);
    }

    private void OnHotkeyChangedAtom2View(string key)
    {
        if (false) SuperController.LogMessage("[INF] Atom2View key changed : " + key);
        
        hotkey_A2V = (KeyCode)Enum.Parse(typeof(KeyCode), key);
    }

    private void FitView2Atom()
    {
        setAtomTransform(containingAtom, SuperController.singleton.centerCameraTarget.transform);
    }

    private void FitAtom2View()
    {
        setViewTransform(containingAtom.mainController.control);
    }
    
    /////////////////////////////////// new mode

    void registerTransform()
    {
        for (int i = 0; i < 10; i++)
        {
            trans[i] = new JSONStorableFloat[6];
            String id = "T" + (i+1).ToString("00");
       
            trans[i][0] = new JSONStorableFloat(id + "_rot_x", 0.0f, /* Caback, */-1000f, 1000f);
            trans[i][1] = new JSONStorableFloat(id + "_rot_y", 0.0f, /* Caback, */-1000f, 1000f);
            trans[i][2] = new JSONStorableFloat(id + "_rot_z", 0.0f, /* Caback, */-1000f, 1000f);
            trans[i][3] = new JSONStorableFloat(id + "_pos_x", 0.0f, /* Caback, */-1000f, 1000f);
            trans[i][4] = new JSONStorableFloat(id + "_pos_y", 0.0f, /* Caback, */-1000f, 1000f);
            trans[i][5] = new JSONStorableFloat(id + "_pos_z", 0.0f, /* Caback, */-1000f, 1000f);  
  
            trans[i][0].storeType = JSONStorableParam.StoreType.Full;
            trans[i][1].storeType = JSONStorableParam.StoreType.Full;
            trans[i][2].storeType = JSONStorableParam.StoreType.Full;
            trans[i][3].storeType = JSONStorableParam.StoreType.Full;
            trans[i][4].storeType = JSONStorableParam.StoreType.Full;
            trans[i][5].storeType = JSONStorableParam.StoreType.Full;
            
            RegisterFloat(trans[i][0]);
            RegisterFloat(trans[i][1]);
            RegisterFloat(trans[i][2]);
            RegisterFloat(trans[i][3]);
            RegisterFloat(trans[i][4]);
            RegisterFloat(trans[i][5]);  
        }
    }

    void registerAction()
    {
        UIDynamicButton btn01 = CreateButton("Fit Cam2View01");
        var             act01 = new JSONStorableAction("Fit Cam2View01", fitCam2View01);
        RegisterAction(act01);
        act01.dynamicButton = btn01;   
        btn01.button.onClick.AddListener(fitCam2View01);
        
        UIDynamicButton btn02 = CreateButton("Fit Cam2View02");
        var             act02 = new JSONStorableAction("Fit Cam2View02", fitCam2View02);
        RegisterAction(act02);
        act02.dynamicButton = btn02;   
        btn02.button.onClick.AddListener(fitCam2View02);
        
        UIDynamicButton btn03 = CreateButton("Fit Cam2View03");
        var             act03 = new JSONStorableAction("Fit Cam2View03", fitCam2View03);
        RegisterAction(act03);
        act03.dynamicButton = btn03;   
        btn03.button.onClick.AddListener(fitCam2View03);
        
        UIDynamicButton btn04 = CreateButton("Fit Cam2View04");
        var             act04 = new JSONStorableAction("Fit Cam2View04", fitCam2View04);
        RegisterAction(act04);
        act04.dynamicButton = btn04;   
        btn04.button.onClick.AddListener(fitCam2View04);
        
        UIDynamicButton btn05 = CreateButton("Fit Cam2View05");
        var             act05 = new JSONStorableAction("Fit Cam2View05", fitCam2View05);
        RegisterAction(act05);
        act05.dynamicButton = btn05;   
        btn05.button.onClick.AddListener(fitCam2View05);
        
        UIDynamicButton btn06 = CreateButton("Fit Cam2View06");
        var             act06 = new JSONStorableAction("Fit Cam2View06", fitCam2View06);
        RegisterAction(act06);
        act06.dynamicButton = btn06;   
        btn06.button.onClick.AddListener(fitCam2View06);
        
        UIDynamicButton btn07 = CreateButton("Fit Cam2View07");
        var             act07 = new JSONStorableAction("Fit Cam2View07", fitCam2View07);
        RegisterAction(act07);
        act07.dynamicButton = btn07;   
        btn07.button.onClick.AddListener(fitCam2View07);
        
        UIDynamicButton btn08 = CreateButton("Fit Cam2View08");
        var             act08 = new JSONStorableAction("Fit Cam2View08", fitCam2View08);
        RegisterAction(act08);
        act08.dynamicButton = btn08;   
        btn08.button.onClick.AddListener(fitCam2View08);
        
        UIDynamicButton btn09 = CreateButton("Fit Cam2View09");
        var             act09 = new JSONStorableAction("Fit Cam2View09", fitCam2View09);
        RegisterAction(act09);
        act09.dynamicButton = btn09;   
        btn09.button.onClick.AddListener(fitCam2View09);
        
        UIDynamicButton btn10 = CreateButton("Fit Cam2View10");
        var             act10 = new JSONStorableAction("Fit Cam2View10", fitCam2View10);
        RegisterAction(act10);
        act10.dynamicButton = btn10;   
        btn10.button.onClick.AddListener(fitCam2View10);
    }

    protected void Caback(JSONStorableFloat callback)
    {
        SuperController.LogMessage("callback : " + callback.val);
    }
        
    void Start() 
    {
        world_w = world_h = (int)WORLD_X.val;
        maps.revalidate();
           
        if (false) SuperController.LogMessage("[INF] set scale : " + world_w);
        for (int i = 0; i < 10; i++)
        {
            if (false) SuperController.LogMessage("[INF] read Storable Transform [" + i + "] rot (" + trans[i][0].val + "," + trans[i][1].val + "," + trans[i][2].val + ") pos(" + trans[i][3].val + "," + trans[i][4].val + "," + trans[i][5].val + ")");
            setCamsTransform(i, trans[i][0].val, trans[i][1].val, trans[i][2].val, trans[i][3].val, trans[i][4].val, trans[i][5].val);
        }
    }
    
    void OnGUI() 
    {
        OnGUIHUD();
    }

    void Update()
    {
        if (Input.GetKeyDown(hotkey_V2A)) FitView2Atom(); /* legacy mode */
        if (Input.GetKeyDown(hotkey_A2V)) FitAtom2View(); /* legacy mode */
        
        UpdateHUD();
    }
    
    void FixedUpdate()
    {
        
    }    
    
    private IEnumerator InitDeferred()
    {
        yield return new WaitForEndOfFrame();
        if (!enabled) yield break;



    }
    
    void OnEnable()
    {

    }

    void OnDisable()
    {

    }    
    
    public void OnDestroy()
    {
        SuperController.singleton.BroadcastMessage("OnActionsProviderDestroyed", this, SendMessageOptions.DontRequireReceiver);
    }
    
    ///////////////////////////////////////////////////////////////////////////    
    
    private void fitCam2View01()
    {
        setViewTransform(getCamsTransform(0));
    }
    private void fitCam2View02()
    {
        setViewTransform(getCamsTransform(1));
    }
    private void fitCam2View03()
    {
        setViewTransform(getCamsTransform(2));
    }
    private void fitCam2View04()
    {
        setViewTransform(getCamsTransform(3));
    }
    private void fitCam2View05()
    {
        setViewTransform(getCamsTransform(4));
    }
    private void fitCam2View06()
    {
        setViewTransform(getCamsTransform(5));
    }
    private void fitCam2View07()
    {
        setViewTransform(getCamsTransform(6));
    }
    private void fitCam2View08()
    {
        setViewTransform(getCamsTransform(7));
    }
    private void fitCam2View09()
    {
        setViewTransform(getCamsTransform(8));
    }
    private void fitCam2View10()
    {
        setViewTransform(getCamsTransform(9));
    }
    
    ///////////////////////////////////////////////////////////////////////////    
    
    public Transform[]t10;
    public JSONStorableFloat[][]trans = new JSONStorableFloat[10][];
    
    public Transform getCamsTransform(int idx)
    {
        return t10[idx];
    }    
    
    public Transform getViewTransform()
    {
        Transform t = SuperController.singleton.centerCameraTarget.transform;
        return t;
    }    
    
    private void setAtomTransform(Atom a, Transform t)
    {
        a.freeControllers[0].currentPositionState = FreeControllerV3.PositionState.Lock;
        a.freeControllers[0].currentRotationState = FreeControllerV3.RotationState.Lock;

        a.freeControllers[0].transform.position = t.position;
        a.freeControllers[0].transform.rotation = t.rotation;
        
        if (false) SuperController.LogMessage("[INF] setAtomTransform : " + t.position + " " + t.position);
    }    
    
    
    public void setCamsTransform(int idx, Transform t)
    {
        if (t10[idx] == null)
        {
            t10[idx] = new GameObject().transform;   
        }
        
        t10[idx].eulerAngles = t.eulerAngles;
        t10[idx].position    = t.position;
        
        /////
        
        {
            Vector3 rot = t.eulerAngles;
            Vector3 pos = t.position;
            trans[idx][0].val = rot.x;
            trans[idx][1].val = rot.y;
            trans[idx][2].val = rot.z;
            
            trans[idx][3].val = pos.x;
            trans[idx][4].val = pos.y;
            trans[idx][5].val = pos.z;
        }
        
        if (false) SuperController.LogMessage("[INF] setCamsTransform : " + t10[idx].eulerAngles + " " + t10[idx].position);
    }    
    
    public void setCamsTransform(int idx, float rot_x, float rot_y, float rot_z, float pos_x, float pos_y, float pos_z)
    {// json float to local value
        if (rot_x == 0 && rot_y == 0 && rot_z == 0 &&
            pos_x == 0 && pos_y == 0 && pos_z == 0) return;
        
        if (t10[idx] == null)
        {
            t10[idx] = new GameObject().transform;   
        }
        
        t10[idx].eulerAngles = new Vector3(rot_x, rot_y, rot_z);
        t10[idx].position    = new Vector3(pos_x, pos_y, pos_z);
        
        /////
        
        {
            trans[idx][0].val = rot_x;
            trans[idx][1].val = rot_y;
            trans[idx][2].val = rot_z;
            trans[idx][3].val = pos_x;
            trans[idx][4].val = pos_y;
            trans[idx][5].val = pos_z;
        }
        
        if (false) SuperController.LogMessage("[INF] setCamsTransform : " + t10[idx].eulerAngles + " " + t10[idx].position);
        
    }
    
    public void setViewTransform(Transform t)
    {
        if (t == null) return;
        
        SuperController.singleton.ResetNavigationRigPositionRotation();
        var super_controller = SuperController.singleton;
        
        var navigationT = super_controller.navigationRig.transform;
        var centCamTgtT = super_controller.centerCameraTarget.transform;
        var teleportPos = t.position + (navigationT.position - centCamTgtT.position);
        var monCentCamT = super_controller.MonitorCenterCamera.transform;
        
        navigationT.eulerAngles = new Vector3(0, t.eulerAngles.y, 0);
        navigationT.position = new Vector3(teleportPos.x, 0, teleportPos.z);

        if (true) //enableUpdatePlayerHeightAdjust.val)
        {
            super_controller.playerHeightAdjust += (t.position.y - centCamTgtT.position.y);
        }

        monCentCamT.eulerAngles = t.eulerAngles;
        monCentCamT.localEulerAngles = new Vector3(monCentCamT.localEulerAngles.x, 0, 0);
        
        if (false) SuperController.LogMessage("[INF] setViewTransform : " + t.eulerAngles + " " + t.position);
    }      
    
    /////////////////////////////////////////////////////////////////////////// Part of HUD 

    public View2AtomPanel         pane; // panel
    public View2AtomPanelCam      camc; // cam control
    public View2AtomPanelMap      maps; // map viewer
    public View2AtomPanelMapCtrl  mctr; // map control
    public View2AtomPanelProperty prop; // properties
    public View2AtomPanelText     text; // properties
    
    public int  panel_x = 0;
    public int  panel_y = 0;
    public int  panel_w = 0;
    public int  panel_h = 0;  
    
    void InitHUD()
    {
        this.t10 = new Transform[10];
        this.panel_w = 300;
        this.panel_h = 455;   
        this.panel_x = Screen.width - panel_w - 2; // - 300;
        this.panel_y = 4; 
        
        this.pane = new View2AtomPanel(this);
        this.camc = new View2AtomPanelCam(this);
        this.maps = new View2AtomPanelMap(this);
        this.mctr = new View2AtomPanelMapCtrl(this);
        this.prop = new View2AtomPanelProperty(this);
        this.text = new View2AtomPanelText(this);
    }
    
    public JSONStorableBool hideHUD;
    public JSONStorableBool invertZ;
    public int  world_w = 8;
    public int  world_h = 8;
    public JSONStorableFloat WORLD_X;
    
    void OnGUIHUD() 
    {
        if (hideHUD.val) return;
        
        Vector2 mousepos = new Vector2(Input.mousePosition.x, Screen.height - Input.mousePosition.y);     
                
        pane.draw(mousepos);
        camc.draw(mousepos);
        maps.draw(mousepos);
        mctr.draw(mousepos);
        prop.draw(mousepos);
        text.draw(mousepos);
        
        if (false) View2AtomUtil.drawRectangle(pane.panel_r, new Color(0, 0, 1, 0.5f));
        if (false) View2AtomUtil.drawRectangle(pane.title_r, new Color(1, 0, 0, 0.5f));
        if (false) View2AtomUtil.drawRectangle(camc.panel_r, new Color(1, 0, 0, 0.5f));
        if (false) View2AtomUtil.drawRectangle(camc.btnup_r, new Color(1, 0, 0, 0.5f));
        if (false) View2AtomUtil.drawRectangle(camc.btndn_r, new Color(1, 0, 0, 0.5f));
        if (false) View2AtomUtil.drawRectangle(maps.panel_r, new Color(1, 0, 0, 0.5f));
        if (false) View2AtomUtil.drawRectangle(mctr.panel_r, new Color(1, 0, 0, 0.5f));
        if (false) View2AtomUtil.drawRectangle(prop.panel_r, new Color(1, 0, 0, 0.5f));
        if (false) View2AtomUtil.drawRectangle(text.panel_r, new Color(1, 0, 0, 0.5f));        
    }
    
    void UpdateHUD() 
    {// mouse event here~
        if (hideHUD.val) return;
        
        Event e = Event.current;
        Vector2 mousepos = new Vector2(Input.mousePosition.x, Screen.height - Input.mousePosition.y);   
        if (Input.GetMouseButtonDown(0) || Input.GetMouseButtonDown(1)) //if (e.type == EventType.MouseDown || e.type == EventType.MouseUp)
        if (pane.contains(mousepos.x, mousepos.y))
        {
            pane.update(mousepos);
            camc.update(mousepos);
            maps.update(mousepos);
            mctr.update(mousepos);
            prop.update(mousepos);
            text.update(mousepos);                
            
           int pas_id = GUIUtility.GetControlID(FocusType.Passive);
           int act_id = GUIUtility.GetControlID(GetHashCode(), FocusType.Passive);
           int nat_id = GUIUtility.GetControlID(FocusType.Native);
           
         //mouse event consume bug here~, how to let me know ...
           if (false) SuperController.LogMessage("[INF] mouse event consume ...");
           Event.current.Use();
           e.Use();
        }
        
        fps(); 
    }

    ///////////////////////////////////
    
    static  float fpsTimes = 0.49f;
    private float fpsCount = 0;
    private float fpsTimer = Time.realtimeSinceStartup + fpsTimes;
    public  float fpsValue;
    public void fps()
    {
        fpsCount++;
        if (fpsTimer < Time.realtimeSinceStartup)
        {
            fpsValue = (float)fpsCount / fpsTimes;
            fpsTimer+= fpsTimes;
            fpsCount = 0;
        } 
    }  
    
    ///////////////////////////////////
    
    
}


    