using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.Events;
using System.Collections;
using System.Collections.Generic;

//20240429@14mhz

public class View2AtomPanelCam
{
    View2Atom main;
    public int  panel_x;
    public int  panel_y;
    public int  panel_w;
    public int  panel_h;
    public Rect panel_r;
    
    public int  space_x = 2;
    public int  space_y = 2;

    public int  btnup_x;
    public int  btnup_y;
    public int  btnup_w;
    public int  btnup_h;
    public Rect btnup_r;
    
    public int  btndn_x;
    public int  btndn_y;
    public int  btndn_w;
    public int  btndn_h;
    public Rect btndn_r;
    
    public View2AtomPanelCam(View2Atom main)
    {
        this.main = main;
        revalidate();
    }
    
    public void revalidate()
    {
        this.panel_x = main.pane.panel_x + space_x;
        this.panel_y = main.pane.title_y + main.pane.title_h + space_y;
        this.panel_w = main.pane.panel_w - space_x*2;
        this.panel_h = 32;
        this.panel_r = new Rect(panel_x, panel_y, panel_w, panel_h);
        
        this.btnup_x = panel_x;
        this.btnup_y = panel_y;
        this.btnup_w = panel_w;
        this.btnup_h = 20;
        this.btnup_r = new Rect(btnup_x, btnup_y, btnup_w, btnup_h);
        
        this.btndn_x = panel_x;
        this.btndn_y = btnup_y + btnup_h + space_y;
        this.btndn_w = panel_w;
        this.btndn_h = 10;
        this.btndn_r = new Rect(btndn_x, btndn_y, btndn_w, btndn_h);
        
        {
            int b_w = 26;
            int b_h = btnup_h;
            int gap = 4;
            
            r0 = new Rect[10];
            t0 = new Rect[10];
            
            for (int i = 0; i < 10; i++)
            {
                int  x = btnup_x + (b_w + gap) * i;
                int  y = btnup_y;
                r0[i] = new Rect(x, y, b_w, b_h);
                t0[i] = new Rect(x + (i+1 < 10 ? 9 : 4), y-1, b_w, b_h);
            }
        }
        
        {
            int b_w = 26; // 12 + 2 + 12
            int b_h = btndn_h;
            int gap = 4;
            
            r1 = new Rect[10];
            r2 = new Rect[10];
            
            for (int i = 0; i < 10; i++)
            {
                int   x = btndn_x + (b_w + gap) * i;
                int   y = btndn_y;
                r1[i] = new Rect(x + 0 +  0, y, 12, b_h);
                r2[i] = new Rect(x + 2 + 12, y, 12, b_h);            
            }                
        }        
    }
    
    public bool contains(float x, float y)
    {
        return View2AtomUtil.contains(panel_r, x, y);
    }
    
    ///////////////////////////////////

    Rect[]r0;
    Rect[]t0;
    Rect[]r1;
    Rect[]r2;

    bool[]canCapture = new bool[10];
    bool[]canCopyies = new bool[10];

    public void draw(Vector2 mousepos)
    {
        for (int i = 0; i < 10; i++)
        {
          //View2AtomUtil.drawRectangle(r0[i], View2AtomUtil.contains(r0[i], mousepos.x, mousepos.y) ? Color.gray : Color.black);
            View2AtomUtil.drawRectangle(r0[i], canCapture[i] ? Color.red : (canCopyies[i] ? new Color(1, 0.4f, 0, 1f) : main.t10[i] == null ? Color.black : Color.gray));
            
            View2AtomUtil.drawText(t0[i], View2AtomUtil.contains(t0[i], mousepos.x, mousepos.y) ? Color.black : Color.white, 14, (i+1).ToString());
            
            View2AtomUtil.drawRectangle(r1[i], View2AtomUtil.contains(r1[i], mousepos.x, mousepos.y) ? Color.gray : Color.black); 
            View2AtomUtil.drawRectangle(r2[i], View2AtomUtil.contains(r2[i], mousepos.x, mousepos.y) ? Color.gray : Color.black);       
        }
    }

    public void update(Vector2 mousepos)
    {
        if (contains(mousepos.x, mousepos.y) == false) return;
        if (Input.GetMouseButtonDown(0) == false && Input.GetMouseButtonDown(1) == false) return;
        
        for (int i = 0; i < 10; i++)
        {
            if (View2AtomUtil.contains(r0[i], mousepos.x, mousepos.y))  
            {
                if (false) {}
                else if (Input.GetMouseButtonDown(0)) 
                {
                    if (canCapture[i])
                    {
                        main.setCamsTransform(i, main.getViewTransform());
                    }
                    else
                    {
                        main.setViewTransform(main.getCamsTransform(i));
                        if (false) SuperController.LogMessage("[INF] set View : Rot" + main.t10[i].rotation + " Pos" + main.t10[i].position);
                    }
                    
                    for (int j = 0; j < 10; j++) canCapture[j] = false;
                    for (int j = 0; j < 10; j++) canCopyies[j] = false;
                        
                    break;
                }
                else if (Input.GetMouseButtonDown(1)) 
                {
                    for (int j = 0; j < 10; j++) canCapture[j] = false;
                    for (int j = 0; j < 10; j++) canCopyies[j] = false;
                  //main.t10[i] = null;
                    canCapture[i] = true;
                }
                
                break;
            }   
            
            if (View2AtomUtil.contains(r1[i], mousepos.x, mousepos.y))  
            {
                bool capture_mode = false;
                for (int j = 0; j < 10; j++) { if (canCapture[j]) { capture_mode = true; break; }}
                bool copyies_mode = false;
                for (int j = 0; j < 10; j++) { if (canCopyies[j]) { copyies_mode = true; break; }}
                   
                if (false) SuperController.LogMessage("[INF] copy mode " + capture_mode + "/" + copyies_mode);
                   
                if (false) {}         
                else if (capture_mode)
                {// cencel capture mode
                    for (int j = 0; j < 10; j++) canCapture[j] = false;
                }
                else if (copyies_mode)
                {
                    if (canCopyies[i])
                    {// self
                        for (int j = 0; j < 10; j++) canCopyies[j] = false;
                    }
                    else
                    {// copy to
                        for (int j = 0; j < 10; j++)
                        {
                            if (canCopyies[j])
                            {
                                main.setCamsTransform(i, main.t10[j]);
                                break;
                            }
                        } 
                        
                        for (int j = 0; j < 10; j++) canCapture[j] = false;
                        for (int j = 0; j < 10; j++) canCopyies[j] = false;
                    }
                }
                else
                {// copy from
                    if (main.t10[i] != null)
                    {
                        canCopyies[i] = true;
                    }
                }
                
                break;
            }             

            if (View2AtomUtil.contains(r2[i], mousepos.x, mousepos.y))  
            {// delete
                main.t10[i] = null;
                main.trans[i][0].val = 0;
                main.trans[i][1].val = 0;
                main.trans[i][2].val = 0;
            
                main.trans[i][3].val = 0;
                main.trans[i][4].val = 0;
                main.trans[i][5].val = 0;
                
                for (int j = 0; j < 10; j++) canCapture[j] = false;
                for (int j = 0; j < 10; j++) canCopyies[j] = false;
                break;
            }        
        }
    }
}


    