using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.Events;
using System.Collections;
using System.Collections.Generic;

//20240429@14mhz

public class View2AtomPanelMap
{
    View2Atom main;
    public int  panel_x;
    public int  panel_y;
    public int  panel_w;
    public int  panel_h;
    public Rect panel_r;
    
    public int  space_x = 2;
    public int  space_y = 2;
        
    public View2AtomPanelMap(View2Atom main)
    {
        this.main = main;
        revalidate();
    }

    public void revalidate()
    {
        this.panel_x = main.pane.panel_x + space_x;
        this.panel_y = main.camc.panel_y + main.camc.panel_h + space_y;
        this.panel_w = main.pane.panel_w - space_x*2;
        this.panel_h = panel_w - 40; 
        this.panel_r = new Rect(panel_x, panel_y, panel_w, panel_h);

        this.ratio_w = (float)panel_w / (float)main.world_w;
        this.ratio_h = (float)panel_h / (float)main.world_h;
        this.basis0x = panel_x + panel_w/2;
        this.basis0z = panel_y + panel_h/2;    
        
        rw[0] = new Rect(panel_x, basis0z, panel_w, 1);
        rh[0] = new Rect(basis0x, panel_y, 1, panel_h);    
        
        for (int i = 0; i < main.world_w; i++)
        {
            if (i == 0 || i % (main.world_w/2) == 0) continue;
            rw[i] = new Rect(panel_x + i * ratio_w, panel_y, 1f, panel_h);
        }

        for (int i = 0; i < main.world_h; i++)
        {
            if (i == 0 || i % (main.world_h/2) == 0) continue;
            rh[i] = new Rect(panel_x, panel_y + i * ratio_h, panel_w, 1f);
        }
    }
    
    public bool contains(float x, float y)
    {
        return View2AtomUtil.contains(panel_r, x, y);
    }
    
    ///////////////////////////////////

    public float basis0x;
    public float basis0z;
    public float ratio_w;
    public float ratio_h;

    Rect[]rw = new Rect[32]; // assign max value
    Rect[]rh = new Rect[32]; // assign max value
    Color r_ = new Color(0, 1, 0, 0.3f);

    public void draw(Vector2 mousepos)
    {
        View2AtomUtil.drawRectangle(panel_r, Color.black);
        
        drawAxes(main.world_w, main.world_h, ratio_w, ratio_h, panel_x, panel_y, panel_w, panel_h);
        drawAtoms(mousepos);
    }
    
    void drawAxes(int world_w, int world_h, float ratio_w, float ratio_h, int panel_x, int panel_y, int panel_w, int panel_h)
    {    
        View2AtomUtil.drawRectangle(rw[0], Color.green);
        View2AtomUtil.drawRectangle(rh[0], Color.green);        
        
        for (int i = 0; i < world_w; i++)
        {
            if (i == 0 || i % (world_w/2) == 0) continue;
            View2AtomUtil.drawRectangle(rw[i], r_);
        }

        for (int i = 0; i < world_h; i++)
        {
            if (i == 0 || i % (world_h/2) == 0) continue;
            View2AtomUtil.drawRectangle(rh[i], r_);
        }
    }

    long timer = DateTime.Now.Ticks;
    List<View2AtomUtil.Atomi>enums;
    
    public JSONStorableBool enable_Person ;//  = true;
    public JSONStorableBool enable_Empty  ;//  = true;
    public JSONStorableBool enable_Light  ;//  = true;
    public JSONStorableBool enable_Misc   ;//  = true;
    public JSONStorableBool enable_Asset  ;//  = true;
    
    public JSONStorableBool enable_Camera ;//  = true;
    public JSONStorableBool enable_Sound  ;//  = true;
    public JSONStorableBool enable_Trigger;//  = true;
    public JSONStorableBool enable_Shapes ;//  = true;  
    public JSONStorableBool enable_Another;//  = true;     
    
    public void drawAtoms(Vector2 mousepos)
    {
        if (enums == null || 1000000 * 100 < (DateTime.Now.Ticks - timer))
        {// refresh every 1sec
            timer = DateTime.Now.Ticks;
            enums = View2AtomUtil.generateAtoms(ratio_w, ratio_h);
            if (false) SuperController.LogMessage("[INF] refresh atim ... " + DateTime.Now.Ticks);
        }
        
        float normal_ellipse_size = 24f;
        float select_ellipse_size = 30f;
        
        if (main.world_w <= 8) { normal_ellipse_size = 24 + (8 - main.world_w)*3; select_ellipse_size = 30 + (8 - main.world_w)*3; }
        else                   { normal_ellipse_size = 24 + (8 - main.world_w)/2; select_ellipse_size = 30 + (8 - main.world_w)/2; }
        
        View2AtomUtil.Atomi over = null;
        
        List<View2AtomUtil.Atomi>cam_def = new List<View2AtomUtil.Atomi>(); // default world space view
        List<View2AtomUtil.Atomi>cameras = new List<View2AtomUtil.Atomi>(); // window cameras ...
        
        for (int i = enums.Count - 1; 0 <= i; i--)
        {// person order to last !
            View2AtomUtil.Atomi  a = enums[i];
            float[]pos = a.position(ratio_w, ratio_h, basis0x, basis0z, main.invertZ.val); 
            float  ang = a.angle(main.invertZ.val);
            if (a.isVisible(main.world_w, main.world_h) == false) continue;
            
            if (false) {}
	        else if (a.nme == "DefaultCam")
	        {
	            cam_def.Add(a);
                if (false) over = drawAtom(mousepos, a, pos, ang, normal_ellipse_size, select_ellipse_size, 6, Color.white, Color.red, over);          
	        }
	        else if (a.cat == "People" && a.tpe == "Person")
	        {
                if (enable_Person.val == false) continue;
                over = drawAtom(mousepos, a, pos, ang, normal_ellipse_size, select_ellipse_size, 0, Color.red, Color.white, over);                
	        }
	        else if (a.cat == "None" && a.tpe == "Empty")
	        {
                if (enable_Empty.val == false) continue;
                over = drawAtom(mousepos, a, pos, ang, normal_ellipse_size, select_ellipse_size, 0, Color.red, new Color(0, 1, 0, 1f), over);              
	        }
	        else if (a.cat == "Light")
	        {
                if (enable_Light.val == false) continue;
                over = drawAtom(mousepos, a, pos, ang, normal_ellipse_size, select_ellipse_size, 0, Color.red, new Color(1, 1, 0, 1f), over);          
	        }
            else if (a.cat == "Misc")
            {
                if (enable_Misc.val == false) continue;
                over = drawAtom(mousepos, a, pos, ang, normal_ellipse_size, select_ellipse_size, 0, Color.red, new Color(0, 1, 0, 0.5f), over);          
            }
            else if (a.tpe == "CustomUnityAsset")
            {
                if (enable_Asset.val == false) continue;
                over = drawAtom(mousepos, a, pos, ang, normal_ellipse_size, select_ellipse_size, 0, Color.red, new Color(1, 1, 1, 0.5f), over);          
            }
            
            else if (a.cat == "View" && a.tpe == "WindowCamera")
            {       
                if (enable_Camera.val == false) continue;
                cameras.Add(a);
                if (false) over = drawAtom(mousepos, a, pos, ang, normal_ellipse_size, select_ellipse_size, 0, Color.red, new Color(0, 0, 1, 1f), over);
            }            
            else if (a.cat == "Sound")
            {
                if (enable_Sound.val == false) continue;
                over = drawAtom(mousepos, a, pos, ang, normal_ellipse_size, select_ellipse_size, 0, Color.red, new Color(0, 1, 0, 0.5f), over);          
            }
            else if (a.cat == "Triggers")
            {
                if (enable_Trigger.val == false) continue;
                over = drawAtom(mousepos, a, pos, ang, normal_ellipse_size, select_ellipse_size, 0, Color.red, new Color(1, 1, 0, 0.3f), over);          
            }
            else if (a.cat == "Shapes")
            {
                if (enable_Shapes.val == false) continue;
                over = drawAtom(mousepos, a, pos, ang, normal_ellipse_size, select_ellipse_size, 0, Color.red, new Color(0, 0, 1, 0.5f), over);          
            }
	        else
	        {
                if (enable_Another.val == false) continue;
                over = drawAtom(mousepos, a, pos, ang, normal_ellipse_size, select_ellipse_size, 0, Color.red, new Color(0, 1, 0, 0.5f), over);   
	        }           
        }
        
        for (int i = 0; i < 10; i++)
        {
            if (main.t10[i] == null) continue;
            Transform t = main.t10[i];
            float[]pos = View2AtomUtil.position(ratio_w, ratio_h, basis0x, basis0z, t.position.x, t.position.z, main.invertZ.val); 
            float  ang = View2AtomUtil.angle(t, main.invertZ.val);
            if (View2AtomUtil.isVisible(t, main.world_w, main.world_h) == false) continue;
            
            drawCams(mousepos, pos, ang, normal_ellipse_size, select_ellipse_size, 6, Color.white, new Color(1, 0, 0, 0.5f), i);  
        }
        
        for (int i = 0; i < cam_def.Count; i++)
        {
            View2AtomUtil.Atomi  a = cam_def[i];
            float[]pos = a.position(ratio_w, ratio_h, basis0x, basis0z, main.invertZ.val); 
            float  ang = a.angle(main.invertZ.val);
            if (a.isVisible(main.world_w, main.world_h) == false) continue;
            over = drawAtom(mousepos, a, pos, ang, normal_ellipse_size, select_ellipse_size, 6, Color.white, Color.red, over);  
        }

        for (int i = 0; i < cameras.Count; i++)
        {// window camera order to last !
            View2AtomUtil.Atomi  a = cameras[i];
            float[]pos = a.position(ratio_w, ratio_h, basis0x, basis0z, main.invertZ.val); 
            float  ang = a.angle(main.invertZ.val);
            if (a.isVisible(main.world_w, main.world_h) == false) continue;
            over = drawAtom(mousepos, a, pos, ang, normal_ellipse_size, select_ellipse_size, 0, Color.red, new Color(0, 0, 1, 1f), over);
        }
    }

    public View2AtomUtil.Atomi drawAtom(Vector2 mousepos, View2AtomUtil.Atomi a, float[]pos, float ang, float normal_ellipse_size, float select_ellipse_size, float size_offset, Color pick, Color norm, View2AtomUtil.Atomi over)
    {
        if (over == null && a.contains(mousepos.x, mousepos.y, pos[0], pos[1], normal_ellipse_size))
        {
            over = a; 
            View2AtomUtil.drawAtom(pos[0], pos[1], ang, select_ellipse_size + size_offset, pick);
            main.text.selected_atom = "/" + a.cat + "/" + a.tpe + "/" + a.nme;
        }	            
        
        View2AtomUtil.drawAtom(pos[0], pos[1], ang, normal_ellipse_size + size_offset, norm);
        return over;
    }
    
    public void drawCams(Vector2 mousepos, float[]pos, float ang, float normal_ellipse_size, float select_ellipse_size, float size_offset, Color pick, Color norm, int idx)
    {
        if (View2AtomUtil.contains(mousepos.x, mousepos.y, pos[0], pos[1], normal_ellipse_size))
        {
            View2AtomUtil.drawAtom(pos[0], pos[1], ang, select_ellipse_size + size_offset, pick);
            main.text.selected_atom = "/" + "ViewCamera#" + (idx+1);
        }	            
        
        View2AtomUtil.drawAtom(pos[0], pos[1], ang, normal_ellipse_size + size_offset, norm);
    }
    
    ///////////////////////////////////////////////////////////////////////////

    public void update(Vector2 mousepos)
    {
        if (contains(mousepos.x, mousepos.y) == false) return;
        if (Input.GetMouseButtonDown(0) == false) return;
        
        View2AtomUtil.Atomi pick = null;
        for (int i = 0; i < enums.Count; i++)
        {
            View2AtomUtil.Atomi a = enums[i];
            float[]pos = a.position(ratio_w, ratio_h, basis0x, basis0z, main.invertZ.val); 
            float  ang = a.angle(main.invertZ.val);
            if (a.isVisible(main.world_w, main.world_h) == false) continue;
            
            if (false) {}
	        else if (a.cat == "People" && a.tpe == "Person")
	        {

	        }     
            else if (a.cat == "View" && a.tpe == "WindowCamera")
            {             

            }
	        else if (a.nme == "DefaultCam")
	        {
	            
	        }
	        else if (a.cat == "None" && a.tpe == "Empty")
	        {
	            
	        }
	        else
	        {
	            continue;   
	        }
            
            if (a.contains(mousepos.x, mousepos.y, pos[0], pos[1], 24))
            {
                pick = a;
                break;
            }
        }               
        
        for (int i = 0; i < 10; i++)
        {
            if (main.t10[i] == null) continue;
            Transform t = main.t10[i];
            float[]pos = View2AtomUtil.position(ratio_w, ratio_h, basis0x, basis0z, t.position.x, t.position.z, main.invertZ.val); 
            float  ang = View2AtomUtil.angle(t, main.invertZ.val);
            if (View2AtomUtil.isVisible(t, main.world_w, main.world_h) == false) continue;
            
            if (View2AtomUtil.contains(mousepos.x, mousepos.y, pos[0], pos[1], 24))
            {
                SuperController.LogMessage("[INF] select : " + "/" + "ViewCamera#" + (i+1));
                main.setViewTransform(main.getCamsTransform(i));
                break;
            }
        }
        
        
        if (pick != null) 
        {
            if (false) SuperController.LogMessage("[INF] select : " + pick.cat + "/" + pick.tpe + "/" + pick.nme);
        }
    }
}


    