using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.Events;
using System.Collections;
using System.Collections.Generic;

//20240429@14mhz

public class View2AtomPanelMapCtrl
{
    View2Atom main;
    public int  panel_x;
    public int  panel_y;
    public int  panel_w;
    public int  panel_h;
    public Rect panel_r;
    
    public int  space_x = 2;
    public int  space_y = 2;
    
    public View2AtomPanelMapCtrl(View2Atom main)
    {
        this.main = main;
        revalidate();
    }

    public void revalidate()
    {
        this.panel_x = main.pane.panel_x + space_x;
        this.panel_y = main.maps.panel_y + main.maps.panel_h + space_y;
        this.panel_w = main.pane.panel_w - space_x*2;
        this.panel_h = 20;
        this.panel_r = new Rect(panel_x, panel_y, panel_w, panel_h);
        
        r0 = new Rect(panel_x + 3, panel_y + 3, 14, 14);
        t0 = new Rect(panel_x + 20, panel_y-1, panel_w, panel_h);
        
        {
            int x = panel_x + panel_w - 92 + 2;
            int y = panel_y;
            int w = 14;
            int h =  8;
            
            r1 = new Rect(x, y +  1, w, h);
            r2 = new Rect(x, y + 10, w, h);
            t1 = new Rect(x + 18, y, panel_w, panel_h);
        }    
        
        r3 = new Rect(panel_x, panel_y + panel_h, panel_w, 1f);
    }
    
    public bool contains(float x, float y)
    {
        return View2AtomUtil.contains(panel_r, x, y);
    }
    
    ///////////////////////////////////

    Rect r0;
    Rect t0;
    Rect r1;
    Rect r2;
    Rect t1;
    Rect r3;

    public void draw(Vector2 mousepos)
    {
      //View2AtomUtil.drawRectangle(r0, View2AtomUtil.contains(r0, mousepos.x, mousepos.y) ? Color.gray : Color.black);
        View2AtomUtil.drawcheck(r0, Color.white, main.invertZ.val);
        View2AtomUtil.drawText(t0, main.invertZ.val ?  Color.black : Color.gray, 14, "Invert Z-Axsis");
        
        {
            View2AtomUtil.drawRectangle(r1, View2AtomUtil.contains(r1, mousepos.x, mousepos.y) ? Color.gray : Color.black);    
            View2AtomUtil.drawRectangle(r2, View2AtomUtil.contains(r2, mousepos.x, mousepos.y) ? Color.gray : Color.black);    
            View2AtomUtil.drawText(t1, Color.black, 12, "Size ("+ main.world_w.ToString() + "x" + main.world_w.ToString() + ")");
        }
        
        View2AtomUtil.drawRectangle(r3, Color.gray);
    }
    
    public void update(Vector2 mousepos)
    {
        if (contains(mousepos.x, mousepos.y) == false) return;
        if (Input.GetMouseButtonDown(0) == false) return;
        
        if (View2AtomUtil.contains(r0, mousepos.x, mousepos.y))
        {
            main.invertZ.val = !main.invertZ.val;
            return;
        }   
        
        int x = panel_x + panel_w - 92 + 2;
        int y = panel_y;
        int w = 14;
        int h =  8;
        
        if (View2AtomUtil.contains(r1, mousepos.x, mousepos.y))
        {
            if (false) SuperController.LogMessage("[INF] rescale up");
            main.world_w = (int)Mathf.Max(2, (main.world_w - 2));
            main.world_h = (int)Mathf.Max(2, (main.world_h - 2));
            main.WORLD_X.val = main.world_w;
            main.maps.revalidate();
            return;
        }

        if (View2AtomUtil.contains(r2, mousepos.x, mousepos.y))
        {
            if (false) SuperController.LogMessage("[INF] rescale dn");
            main.world_w = (int)Mathf.Min(32, (main.world_w + 2));
            main.world_h = (int)Mathf.Min(32, (main.world_h + 2));
            main.WORLD_X.val = main.world_w;
            main.maps.revalidate();
            return;
        }
    }
}


    