using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.Events;
using System.Collections;
using System.Collections.Generic;

//20240429@14mhz

public class View2AtomPanelProperty
{
    View2Atom main;
    public int  panel_x;
    public int  panel_y;
    public int  panel_w;
    public int  panel_h;
    public Rect panel_r;
    
    public int  space_x = 2;
    public int  space_y = 2;
    
    public View2AtomPanelProperty(View2Atom main)
    {
        this.main = main;
        revalidate();
        
        this.mesg = new String[2][]; 
        this.mesg[0] = new String[]{"Enable Person", "Enable Empty", "Enable Light"  , "Enable Misc"  , "Enable UnityAsset" };
        this.mesg[1] = new String[]{"Enable Camera", "Enable Sound", "Enable Trigger", "Enable Shapes", "Enable Another"};
    }

    public void revalidate()
    {
        this.panel_x = main.pane.panel_x + space_x;
        this.panel_y = main.mctr.panel_y + main.mctr.panel_h + space_y;
        this.panel_w = main.pane.panel_w - space_x*2;
        this.panel_h = main.pane.panel_h - panel_y - 20;
        this.panel_r = new Rect(panel_x, panel_y, panel_w, panel_h);
        
        rect = new Rect[2][];
        rect[0] = new Rect[5];
        rect[1] = new Rect[5];
        
        text = new Rect[2][];
        text[0] = new Rect[5];
        text[1] = new Rect[5];
        
        for (int i = 0; i < 2; i++)
        for (int j = 0; j < 5; j++)
        {
            rect[i][j] = new Rect(panel_x + 3 + panel_w/2*i, panel_y + 3 + 18*j, 14, 14); 
            text[i][j] = new Rect(panel_x + 20 + panel_w/2*i, panel_y-1 + 18*j, panel_w, panel_h); 
        }
    }
    
    public bool contains(float x, float y)
    {
        return View2AtomUtil.contains(panel_r, x, y);
    }
    
    ///////////////////////////////////

    String[][]mesg;
    Rect[][]  rect;  
    Rect[][]  text;   
        
    public void draw(Vector2 mousepos)
    {
        for (int i = 0; i < 2; i++)
        for (int j = 0; j < 5; j++)
        {
          //View2AtomUtil.drawRectangle(rect[i][j], View2AtomUtil.contains(rect[i][j], mousepos.x, mousepos.y) ? Color.gray : Color.black);
            View2AtomUtil.drawcheck(rect[i][j], Color.white, isCheck(i, j));
            View2AtomUtil.drawText(text[i][j], isCheck(i, j) ? Color.black : Color.gray, 14, mesg[i][j]);
        }
    }
    
    public void update(Vector2 mousepos)
    {
        if (contains(mousepos.x, mousepos.y) == false) return;
        if (Input.GetMouseButtonDown(0) == false) return;
        
        for (int i = 0; i < 2; i++)
        for (int j = 0; j < 5; j++)
        {
            if (View2AtomUtil.contains(rect[i][j], mousepos.x, mousepos.y))
            {
                if (false) SuperController.LogMessage("[INF] " + text[i][j] + " clicked ...");
                
                if (false) {}
                else if (i == 0 && j == 0) { main.maps.enable_Person.val  = !main.maps.enable_Person.val ; return; }
                else if (i == 0 && j == 1) { main.maps.enable_Empty.val   = !main.maps.enable_Empty.val  ; return; }
                else if (i == 0 && j == 2) { main.maps.enable_Light.val   = !main.maps.enable_Light.val  ; return; }
                else if (i == 0 && j == 3) { main.maps.enable_Misc.val    = !main.maps.enable_Misc.val   ; return; }
                else if (i == 0 && j == 4) { main.maps.enable_Asset.val   = !main.maps.enable_Asset.val  ; return; }
                
                else if (i == 1 && j == 0) { main.maps.enable_Camera.val  = !main.maps.enable_Camera.val ; return; }
                else if (i == 1 && j == 1) { main.maps.enable_Sound.val   = !main.maps.enable_Sound.val  ; return; }
                else if (i == 1 && j == 2) { main.maps.enable_Trigger.val = !main.maps.enable_Trigger.val; return; }
                else if (i == 1 && j == 3) { main.maps.enable_Shapes.val  = !main.maps.enable_Shapes.val ; return; }
                else if (i == 1 && j == 4) { main.maps.enable_Another.val = !main.maps.enable_Another.val; return; }
            }
        }
    }
    
    bool isCheck(int i, int j)
    {
        if (false) {}
        else if (i == 0 && j == 0) { return main.maps.enable_Person.val ; }
        else if (i == 0 && j == 1) { return main.maps.enable_Empty.val  ; }
        else if (i == 0 && j == 2) { return main.maps.enable_Light.val  ; }
        else if (i == 0 && j == 3) { return main.maps.enable_Misc.val   ; }
        else if (i == 0 && j == 4) { return main.maps.enable_Asset.val  ; }
         
        else if (i == 1 && j == 0) { return main.maps.enable_Camera.val ; }
        else if (i == 1 && j == 1) { return main.maps.enable_Sound.val  ; }
        else if (i == 1 && j == 2) { return main.maps.enable_Trigger.val; }
        else if (i == 1 && j == 3) { return main.maps.enable_Shapes.val ; }
        else if (i == 1 && j == 4) { return main.maps.enable_Another.val; }
        
        return false;
    }
}


    