using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.Events;
using System.Collections;
using System.Collections.Generic;
using MVR.FileManagementSecure;

//20240429@14mhz

public class View2AtomUtil
{
    /////////////////////////////////// drawing
    
    public static String HOME;
    static Texture2D close_norm;
    static Texture2D close_over;
    public static void drawclose(Rect r, Color c, bool over)
    {
        if (close_norm == null)
        {
            byte[]close_norm_b = FileManagerSecure.ReadAllBytes(HOME + "/resource/btn-nm.png");
            byte[]close_over_b = FileManagerSecure.ReadAllBytes(HOME + "/resource/btn-ov.png");
            
            close_norm = new Texture2D(2, 2, TextureFormat.ARGB32, true, false);
            close_over = new Texture2D(2, 2, TextureFormat.ARGB32, true, false);
            
            close_norm.LoadImage(close_norm_b); 
            close_over.LoadImage(close_over_b); 
            
          //close_norm = TextureLoader.LoadTexture(HOME + "/resource/btn-nm.png");
          //close_over = TextureLoader.LoadTexture(HOME + "/resource/btn-ov.png");
        }        
        
        GUI.color = c;
        GUI.DrawTexture(r, over ? close_over : close_norm);
    } 

    static Texture2D check_v;
    static Texture2D check_x;
    public static void drawcheck(Rect r, Color c, bool check)
    {
        if (check_v == null)
        {
            byte[]check_v_b = FileManagerSecure.ReadAllBytes(HOME + "/resource/check_v.png");
            byte[]check_x_b = FileManagerSecure.ReadAllBytes(HOME + "/resource/check_x.png");            
            
            check_v = new Texture2D(2, 2, TextureFormat.ARGB32, true, false);
            check_x = new Texture2D(2, 2, TextureFormat.ARGB32, true, false);
            
            check_v.LoadImage(check_v_b); 
            check_x.LoadImage(check_x_b);             
            
          //check_v = TextureLoader.LoadTexture(HOME + "/resource/check_v.png");
          //check_x = TextureLoader.LoadTexture(HOME + "/resource/check_x.png");
        }        
        
        GUI.color = c;
        GUI.DrawTexture(r, check ? check_v : check_x);
    }    
    
    static Texture2D texrect;
    public static void drawRectangle(float x, float y, float w, float h, Color c)
    {
        drawRectangle(new Rect(x, y, w, h), c);
    }
    
    public static void drawRectangle(Rect r, Color c)
    {
        if (texrect == null)
        {
            texrect = new Texture2D(300, 300);
            texrect.SetPixel(0, 0, UnityEngine.Color.white);
            texrect.Apply();            
        }
        
        GUI.color = c;
        GUI.DrawTexture(r, texrect);
    }
    
    
    public static void drawText(float x, float y, float w, float h, Color c, int size, String text)
    {
        drawText(new Rect(x, y, w, h), c, size, text);
    }    
    
    public static void drawText(Rect r, Color c, int size, String text)
    {
        if (texrect == null)
        {
            texrect = new Texture2D(300, 300);
            texrect.SetPixel(0, 0, UnityEngine.Color.white);
            texrect.Apply();            
        }
        
        GUI.color = c;
	    GUI.skin.label.fontSize = size;   
        GUI.Label(r, text);
    }
    
    /////////////////////////////////// geometry

    public static bool contains(Rect r, float x, float y)
    {
        if (x < r.x || (r.x + r.width)  < x) return false;
        if (y < r.y || (r.y + r.height) < y) return false;
        return true;
    }
    
    /////////////////////////////////// hud maps

    public static float[]position(float ratio_w, float ratio_h, float basis0x, float basis0z, float pos_x, float pos_z, bool invertZ)
    {
        float[]p = View2AtomUtil.convertWorld2Huds(pos_x, pos_z, ratio_w, ratio_h, invertZ); 
        p[0] += basis0x;
        p[1] += basis0z;
        return p;
    }

    public static float angle(Transform t, bool invertZ)
    {
        Vector3 d = t.TransformDirection(invertZ ? Vector3.forward : Vector3.back);
        float   a = View2AtomUtil.convertDirection2Angle(d);  
        return  a;
    }

    public static bool isVisible(Transform t, float  world_w, float  world_h)
    {
        if (t == null) return false;
        
        float world_w_half = world_w/2;
        float world_h_half = world_h/2;        
        
        if (world_w_half - 0.3 < Mathf.Abs(t.position.x)) return false;
        if (world_h_half - 0.3 < Mathf.Abs(t.position.z)) return false;
        return true;
    }

    public static bool contains(float mousex, float mousey, float cx, float cy, float size)
    {
        float x = cx - size/2;
        float y = cy - size/2;
        float w = size;
        float h = size;
        
        if (mousex < x || (x + w) < mousex) return false;
        if (mousey < y || (y + h) < mousey) return false;
        return true;
    }

    public static float[] convertWorld2Huds(float real_x, float real_z, float ratio_w, float ratio_h, bool invert)
    {
        float pos_x = (invert ? +1f : -1f) * real_x * ratio_w;
        float pos_z = (invert ? -1f : +1f) * real_z * ratio_h;
        return new float[]{ pos_x, pos_z };    
    }

    public static float convertDirection2Angle(Vector3 dir)
    {
        return Mathf.Atan2(dir.x, dir.z) * Mathf.Rad2Deg;
    }

    public static Transform getTransform(Atom atom)
    {
        if (atom == null || atom.mainController == null) return null;
        else if (atom.category == "People")
        {
            return atom.transform.Find("rescale2/PhysicsModel/Genesis2" + (isFemale(atom) ? "Female" : "Male") + "/hip");
        }
        else
        {
            return atom.mainController.control.transform;
        }
    }

    /////////////////////////////////// atoms control

    static Texture2D tex_dot;
    public static void drawAtom(float x, float y, float angle, float size, Color c)
    {
        if (tex_dot == null)
        {
            byte[]tex_dot_b = FileManagerSecure.ReadAllBytes(HOME + "/resource/circle064.png");            
            
            tex_dot = new Texture2D(2, 2, TextureFormat.ARGB32, true, false);
            
            tex_dot.LoadImage(tex_dot_b);
            
          //tex_dot = TextureLoader.LoadTexture(HOME + "/resource/circle064.png");
        }        
        
        float  px = x - size/2f;
        float  py = y - size/2f;
        
        Rect    r = new Rect(px, py, size, size);
        Vector2 p = new Vector2(x, y);
        
        GUI.color = c;
        GUIUtility.RotateAroundPivot (+angle, p);
        GUI.DrawTexture(r, tex_dot);
        GUIUtility.RotateAroundPivot (-angle, p);        
        /*
        float direct_size = size/4f; 
        GUI.color = Color.black;
        GUIUtility.RotateAroundPivot (+angle, new Vector2(x, y));
        GUI.DrawTexture(new Rect(x - direct_size/2f, y - direct_size/2f - (size/2f - direct_size), direct_size, direct_size), tex_dot);
        GUIUtility.RotateAroundPivot (-angle, new Vector2(x, y));
        */
    }
    
    public class Atomi
    {// Atom information
        
        public Atom      a;
        public Transform t;
        public String    nme;
        public String    cat;
        public String    tpe;
        
        public Atomi(Atom a, Transform t)
        {   
            this.a = a;
            this.t = t;
            this.nme = a.name;
            this.cat = a.category;
            this.tpe = a.type;
        }
        
        public Atomi(Transform t, string name)
        {// CameraTarget only   
            this.a = null;
            this.t = t;
            this.nme = name;
            this.cat = name;
            this.tpe = name;
        }        
        
        public float[]position(float ratio_w, float ratio_h, float basis0x, float basis0z, bool invertZ)
        {
            float[]p = View2AtomUtil.convertWorld2Huds(t.position.x, t.position.z, ratio_w, ratio_h, invertZ); 
            p[0] += basis0x;
            p[1] += basis0z;
            return p;
        }
        
        public float angle(bool invertZ)
        {
            Vector3 d = t.TransformDirection(invertZ ? Vector3.forward : Vector3.back);
            float   a = View2AtomUtil.convertDirection2Angle(d);  
            return  a;
        }
        
        public bool isVisible(float  world_w, float  world_h)
        {
            if (t == null) return false;
            
            float world_w_half = world_w/2;
            float world_h_half = world_h/2;        
            
            if (world_w_half - 0.3 < Mathf.Abs(t.position.x)) return false;
            if (world_h_half - 0.3 < Mathf.Abs(t.position.z)) return false;
            return true;
        }
        
        public bool contains(float mousex, float mousey, float cx, float cy, float size)
        {
            float x = cx - size/2;
            float y = cy - size/2;
            float w = size;
            float h = size;
            
            if (mousex < x || (x + w) < mousex) return false;
            if (mousey < y || (y + h) < mousey) return false;
            return true;
        }
    }    

    public static List<Atomi>generateAtoms(float ratio_w, float ratio_h)
    {
        var list = new List<Atomi>();   

        {
            Transform t = SuperController.singleton.centerCameraTarget.transform;            
            if (t != null) list.Add(new Atomi(t, "DefaultCam"));
        }

		List<Atom> atoms = SuperController.singleton.GetAtoms();
        try
        {
    		for (int i = 0; i < atoms.Count; ++i)
    		{
    			Atom atom = atoms[i];
                Transform t = View2AtomUtil.getTransform(atom); //atom.mainController.control.transform;
                if (t != null) list.Add(new Atomi(atom, t));
            }
        }
        catch (Exception e)
        {
            SuperController.LogMessage("Failed to init: " + e);
        }      


        return list;
    }    
    
    public static bool isFemale(Atom atom)
    {
        if (atom != null && atom.transform.Find("rescale2/PhysicsModel/Genesis2" + "Female") != null)
        {
            return true;
        }
        return false;
    }  

    ///////////////////////////////////////////////////////////////////////////

	public static string GetPluginPath(MVRScript self)
	{
		var id = self.name.Substring(0, self.name.IndexOf('_'));
		var filename = self.manager.GetJSON()["plugins"][id].Value;
		return filename.Substring(0, filename.LastIndexOfAny(new[] { '/', '\\' }));
	}

    ///////////////////////////////////////////////////////////////////////////
    

}


    